VERSION 2.00
Begin Form Form1 
   BackColor       =   &H00C00000&
   Caption         =   "DragDrop Demonstration Program"
   ClientHeight    =   4020
   ClientLeft      =   1095
   ClientTop       =   1485
   ClientWidth     =   7365
   Height          =   4425
   Left            =   1035
   LinkMode        =   1  'Source
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4020
   ScaleWidth      =   7365
   Top             =   1140
   Width           =   7485
   Begin CommandButton Command1 
      Caption         =   "This Button Does Nothing"
      Height          =   615
      Left            =   4080
      TabIndex        =   7
      Top             =   2160
      Width           =   2895
   End
   Begin TextBox Text3 
      Height          =   375
      Left            =   880
      TabIndex        =   2
      Tag             =   "Text3"
      Text            =   "Text3"
      Top             =   1800
      Width           =   2655
   End
   Begin PictureBox Picture3 
      BackColor       =   &H00C0C0C0&
      Height          =   375
      Left            =   700
      MousePointer    =   5  'Size
      ScaleHeight     =   345
      ScaleWidth      =   165
      TabIndex        =   5
      Tag             =   "Picture3"
      Top             =   1800
      Width           =   200
   End
   Begin TextBox Text2 
      Height          =   375
      Left            =   880
      TabIndex        =   1
      Tag             =   "Text2"
      Text            =   "Text2"
      Top             =   1080
      Width           =   1695
   End
   Begin PictureBox Picture2 
      BackColor       =   &H00C0C0C0&
      Height          =   375
      Left            =   700
      MousePointer    =   5  'Size
      ScaleHeight     =   345
      ScaleWidth      =   165
      TabIndex        =   4
      Tag             =   "Picture2"
      Top             =   1080
      Width           =   200
   End
   Begin TextBox Text1 
      Height          =   375
      Left            =   880
      TabIndex        =   0
      Tag             =   "Text1"
      Text            =   "Text1"
      Top             =   360
      Width           =   1215
   End
   Begin PictureBox Picture1 
      BackColor       =   &H00C0C0C0&
      Height          =   375
      Left            =   700
      MousePointer    =   5  'Size
      ScaleHeight     =   345
      ScaleWidth      =   165
      TabIndex        =   3
      Tag             =   "Picture1"
      Top             =   360
      Width           =   200
   End
   Begin PictureBox Picture4 
      AutoRedraw      =   -1  'True
      Height          =   1695
      Left            =   5400
      ScaleHeight     =   1665
      ScaleWidth      =   1545
      TabIndex        =   6
      Tag             =   "Picture4"
      Top             =   240
      Width           =   1575
   End
   Begin Label Label1 
      Alignment       =   2  'Center
      BackColor       =   &H00FFFF00&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Use The Grey Box At The Left Of The Text Control To DragDrop The Text Control."
      Height          =   495
      Left            =   600
      TabIndex        =   8
      Top             =   3360
      Width           =   6135
   End
End
'=========================================================
'            DRAGDROP DEMONSTRATION PROGRAM
'            Keith Funk (CIS ID 72240, 2020)
'                 Rev. 1.0 July, 1991
'            ------------------------------
'
' This program demonstrates a way to use a Picture Control
' to initiate what appears to be the dragging of a Text
' Control. Some such method is required because Text
' Controls cannot in themselves be DragDropped since they
' don't have a MouseDown Event associated with them.
'
' In addition, it shows some code that prevents a control
' from being dropped on top of another control.
'
' The program works like this. The user press the mouse
' over a picture box (say Picture1). Picture1_MouseDown
' saves the current cursor location then expands the width
' of the picture so that it encompasses the text box to
' its right (the one the user wants to drag). When he
' begins dragging, it *looks* like he is actually dragging
' the text box. MouseDown also initiates dragging.
'
' Every control -and- the form can react to a Drop Event.
' If a control detects a DragDrop, it converts the cursor
' X/Y co-ords (which are relative to the top, left of the
' control) so that they are relative to the top, left of
' the form and then Calls the Form's DragDrop Event.
'
' The form's DragDrop Event calls the Overlap function to
' to check if any part of the dragged control covers any
' part of another control. It then Calls the Sub DropIt
' and either tells it to cancel the drag because of an
' overlap or to move the picture control and its associated
' text control to the new location if there is no overlap.
'
' There is one exception to a control not being allowed to
' overlap another control. The user is allowed to drag
' a control and drop it on top of itself. This lets him
' make small adjustments to the controls position.
'
' Sub DropIt resets the picture control's width back to its
' original width and then either exits if the drag is
' cancelled or uses the Move command to move the picture
' box and text box to the new location.
'
' A note about the Const TextOffset. The picture controls
' used for dragging where created with a width of 200
' twips. Their associated text controls were placed so
' that they overlap the picture controls by 20 twips.
' Thus, the offset is 180 twips. This was done so that
' only a single vertical line separates the two controls.
'
' The large picture control, the label control and the
' command button are included simply to demonstrate the
' code that prevents overlapping controls.
'=========================================================

    Const True = -1
    Const False = 0
    
    '==> Location of Mouse Pointer at start of drag drop.
    '    Values are relative to the top, left corner
    '    of the control on which the mouse was pressed.
    Dim MouseX As Single
    Dim MouseY As Single

    '==> Distance between the left edge of a picture
    '    control and the left edge of its associated
    '    text control.
    Const TextOffset = 180


Sub Command1_DragDrop (Source As Control, X As Single, Y As Single)
    Call Form_DragDrop(Source, X + Command1.Left, Y + Command1.Top)
End Sub

'---------------------------------------------------------
'This routine is called by Form1_DragDrop. It shrinks the
'picture control back to its original width. If the
'requested Action is "OK" then it Moves the picture control
'and its associated text control to the new loaction.
'If the Action is "Cancel", the Move is not performed.
'---------------------------------------------------------
'
Sub DropIt (WhichOne As Control, X As Single, Y As Single, Action As String)
    Select Case WhichOne.Tag
        Case "Picture1"
            Form1.Picture1.Width = Form1.Picture1.Width - Form1.Text1.Width
            If Action <> "Cancel" Then
                '==> Put the top, left corner of the
                '    control in the same position relative
                '    to the cursor as it was before the move.
                Picture1.Move X - MouseX, Y - MouseY
                Text1.Move Picture1.Left + TextOffset, Picture1.Top
            End If
        
        Case "Picture2"
            Picture2.Width = Picture2.Width - Text2.Width
            If Action <> "Cancel" Then
                Picture2.Move X - MouseX, Y - MouseY
                Text2.Move Picture2.Left + TextOffset, Picture2.Top
            End If

        Case "Picture3"
            Picture3.Width = Picture3.Width - Text3.Width
            If Action <> "Cancel" Then
                Picture3.Move X - MouseX, Y - MouseY
                Text3.Move Picture3.Left + TextOffset, Picture3.Top
            End If
    End Select

End Sub

'---------------------------------------------------------
'The DragDrop Procs for *all* controls call this routine.
'Before doing so, these Procs convert their Mouse X/Y
'co-ords so that they are relative to the top, left
'corner of the *form*.
'
'This routine calls the Overlap function for each control
'on the form to see if the control being moved overlaps
'the control. If it does, the DragDrop is cancelled. A
'special case is the text controls that can be DragDropped.
'They can be dropped on themselves.
'
'This routine then calls the routine DropIt which performs
'the Move.
'---------------------------------------------------------
'
Sub Form_DragDrop (Source As Control, X As Single, Y As Single)
    Action$ = "OK"
    If Overlap(Source, Picture1, X, Y) Then Action$ = "Cancel"
    If Overlap(Source, Picture2, X, Y) Then Action$ = "Cancel"
    If Overlap(Source, Picture3, X, Y) Then Action$ = "Cancel"
    If Overlap(Source, Picture4, X, Y) Then Action$ = "Cancel"
    
    If Overlap(Source, Command1, X, Y) Then Action$ = "Cancel"
    If Overlap(Source, Label1, X, Y) Then Action$ = "Cancel"

    '==> Don't check for overlap if the Source control
    '    is the picture control associated with the
    '    destination text control. That is, let the
    '    user DragDrop a control on itself.
    If Source.Tag <> "Picture1" And Overlap(Source, Text1, X, Y) Then Action$ = "Cancel"
    If Source.Tag <> "Picture2" And Overlap(Source, Text2, X, Y) Then Action$ = "Cancel"
    If Source.Tag <> "Picture3" And Overlap(Source, Text3, X, Y) Then Action$ = "Cancel"

    Call DropIt(Source, X, Y, Action$)

End Sub

Sub Form_Load ()
    '==> Let the user know what the square at the top,
    '    right of the form is.
    Form1.Show
    Picture4.CurrentX = 100
    Picture4.CurrentY = 700
    Picture4.Print "Picture Control"
End Sub

Sub Label1_DragDrop (Source As Control, X As Single, Y As Single)
    '==> X + Label1.Left and Y + Label1.Top are used to
    '    convert the cursor location from being relative
    '    to the control's top, left corner to being
    '    relative to the form's top, left corner because
    '    that's the X/Y that the Move command (see DropIt
    '    Sub) requires.
    Call Form_DragDrop(Source, X + Label1.Left, Y + Label1.Top)
End Sub

'---------------------------------------------------------
'This function checks if any part of the Source control
'(the one being DragDropped) overlaps any part of another
'control. If it does, then the function returns True.
'Otherwise it returns False.
'---------------------------------------------------------
Function Overlap (Source As Control, Dest As Control, X As Single, Y As Single) As Integer
    Overlap = False
    
    '==> Allow a picture to be dropped on itself.
    If Source.Tag = Dest.Tag Then Exit Function

    '==> Top left and top right of the Source control.
    XLeft = X - MouseX
    XRight = XLeft + Source.Width

    '==> Check if the top edge of source intersects the
    '    left edge of dest.
    YLeft = Y - MouseY          '=> top left of Source.
    GoSub Check1

    '----- Check if the top,left corner of the source is
    '      inside the dest.
    GoSub Check2

    '----- Check if the bottom edge of source intersects
    '      the left edge of dest.
    YLeft = Y - MouseY + Source.Height
    GoSub Check1
    
    '----- Check if the bottom,left corner of the source
    '      is inside the dest.
    GoSub Check2

    Exit Function

'==> This routine determine if two lines interest.
Check1:
    If (XLeft <= Dest.Left) And (XRight >= Dest.Left) Then
        If (YLeft >= Dest.Top) And (YLeft <= (Dest.Top + Dest.Height)) Then
            Overlap = True
            Exit Function
        End If
    End If
    Return

'==> This routine checks if a point is inside a rectangle.
Check2:
    If (XLeft >= Dest.Left) And (XLeft <= (Dest.Left + Dest.Width)) Then
        If (YLeft >= Dest.Top) And (YLeft <= (Dest.Top + Dest.Height)) Then
            Overlap = True
            Exit Function
        End If
    End If
    Return

End Function

Sub Picture1_DragDrop (Source As Control, X As Single, Y As Single)
    Call Form_DragDrop(Source, X + Picture1.Left, Y + Picture1.Top)
End Sub

Sub Picture1_MouseDown (Button As Integer, Shift As Integer, X As Single, Y As Single)
    '==> Save the current location of the cursor.
    MouseX = X
    MouseY = Y
    
    '==> Expand the picture control to encompass its
    '    associated text control, so it looks to
    '    the user like he is dragging the text control.
    Picture1.Width = Picture1.Width + Text1.Width
    
    '==> Initiate dragging.
    Picture1.Drag 1
End Sub

Sub Picture2_DragDrop (Source As Control, X As Single, Y As Single)
    Call Form_DragDrop(Source, X + Picture2.Left, Y + Picture2.Top)
End Sub

Sub Picture2_MouseDown (Button As Integer, Shift As Integer, X As Single, Y As Single)
    MouseX = X
    MouseY = Y
    Picture2.Width = Picture2.Width + Text2.Width
    Picture2.Drag 1

End Sub

Sub Picture3_DragDrop (Source As Control, X As Single, Y As Single)
    Call Form_DragDrop(Source, X + Picture3.Left, Y + Picture3.Top)
End Sub

Sub Picture3_MouseDown (Button As Integer, Shift As Integer, X As Single, Y As Single)
    MouseX = X
    MouseY = Y
    Picture3.Width = Picture3.Width + Text3.Width
    Picture3.Drag 1

End Sub

Sub Picture4_DragDrop (Source As Control, X As Single, Y As Single)
    Call DropIt(Source, X, Y, "Cancel")
End Sub

Sub Text1_DragDrop (Source As Control, X As Single, Y As Single)
    Call Form_DragDrop(Source, X + Picture1.Left, Y + Picture1.Top)
End Sub

Sub Text2_DragDrop (Source As Control, X As Single, Y As Single)
    Call Form_DragDrop(Source, X + Picture2.Left, Y + Picture2.Top)
End Sub

Sub Text3_DragDrop (Source As Control, X As Single, Y As Single)
    Call Form_DragDrop(Source, X + Picture3.Left, Y + Picture3.Top)
End Sub

